<?php

if ( constant('BRUTAL_CACHE_INSIDE') !== 'SAW_INSIDE' ) { die('No Access'); }

//Cache_delete was pressed
if (isset($_POST['brutal_cache_cache_loeschen'])) {
    $this->delete_cache();
    $notice .= 'Cache wurde gel&ouml;scht';
}

if (isset($_POST['brutal_cache_onefile_cache_loeschen'])) {
    $this->delete_cache($_POST['brutal_cache_onefile']);
    $notice .= 'Cachefile wurde gel&ouml;scht';
}

//Create new config
if (isset($_POST['brutal_cache_change_config'])) {
    if ( isset( $_POST['brutal_cache_timeval_active'] ) ) {
        $this->config['timeval_active'] = ($_POST['brutal_cache_timeval_active'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['timeval_active'] = 0;
    }

    if ( isset( $_POST['brutal_cache_timeval_time'] ) ) {
        $this->config['timeval_time'] = ( intval( $_POST['brutal_cache_timeval_time'] ) * 60 );
    } else {
        $this->config['timeval_time'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_use_user_stored'] ) ) {
        $this->config['use_user_stored'] = ($_POST['brutal_cache_use_user_stored'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['use_user_stored'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_delete_by_admin_call'] ) ) {
        $this->config['delete_by_admin_call'] = ($_POST['brutal_cache_delete_by_admin_call'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['delete_by_admin_call'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_minify_cache'] ) ) {
        $this->config['minify_cache'] = ($_POST['brutal_cache_minify_cache'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['minify_cache'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_reduce_http'] ) ) {
        $this->config['reduce_http'] = ($_POST['brutal_cache_reduce_http'] == 'on') ? 1 : 0 ;
    } else {
        $this->config['reduce_http'] = 0 ;
    }

    if ( isset( $_POST['brutal_cache_hook_prioritat'] ) && intval( $_POST['brutal_cache_hook_prioritat'] ) > 0 && intval( $_POST['brutal_cache_hook_prioritat'] ) < 21 ) {
        $this->config['hook_prioritat'] = intval($_POST['brutal_cache_hook_prioritat']);
    } else {
        $this->config['hook_prioritat'] = 1 ;
    }

    if ( isset( $_POST['brutal_cache_hook_event'] ) ) {

        switch ( $_POST['brutal_cache_hook_event'] ) {
            case 'plugins_loaded':
                $this->config['hook_event'] = 1 ;
                break;
            case 'sanitize_comment_cookies':
                $this->config['hook_event'] = 2 ;
                break;
            case 'setup_theme':
                $this->config['hook_event'] = 3 ;
                break;
            default:
                $this->config['hook_event'] = 1 ;
        }

    }

    $this->save_config_to_file();
}

if ( isset( $_POST['brutal_cache_brutal_mode_change'] ) ) {
    if ( $this->config['brutal_mode'] == 0 ) {
        if ( $this->activate_brutal_mode() ) {
            $this->config['brutal_mode'] = 1 ;
            $notice = 'Brutal Mode aktiviert.';
        }
    } else {
        if ( $this->deactivate_brutal_mode() ) {
            $this->config['brutal_mode'] = 0 ;
            $notice = 'Brutal Mode deaktiviert.';
        }
    }
    if ( $notice === false ) {
        $notice = 'Brutal Mode konnte nicht ge&auml;ndert werden.';
    }
    $this->save_config_to_file();
}

//create output design
echo '<div class="wrap" style="border:1px; margin: 10px 10px 10px 10px;">';
if ($notice !== false) {
    echo '<dir style="border: solid 1px; width:100%; margin: 10px 10px 10px 10px;">'.$notice.'</dir>';
}

//Topic and formstart
echo '<h2> Brutal Cache Konfiguration </h2>'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     '<br /><h3>Haupteinstellung</h3><br />';

//Creating cache new in interval
echo '<b>Soll die Cache in einem gewissen Intervall neu erstellt werden? </b>';
if ($this->config['timeval_active'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_timeval_active" />'.
         '<br /> Wird diese Option deaktiviert, so wird die Cache erst bei einem L&ouml;schaufruf erneuert, '.
         'und niemals zwischendurch. Der Vorteil daran ist, dass wirklich jeder User den Cache erh&auml;lt, '.
         'der Nachteil ist, dass die User immer den Content sehen, welcher nach dem letzten L&ouml;schpunkt '.
         'erstellt wurde.'.
         '<br /><br />'.
         '<b>Aktualisierungsinterval in Minuten: </b>'.
         '<input type="text" value="'.( $this->config['timeval_time'] / 60 ).'" name="brutal_cache_timeval_time" />'.
         '<br /> Diese Option ist nur wichtig, wenn die Option "Cache im Zeitinterval neu erstellen" aktiv ist. '.
         'Dies gibt die Zeit zwischen den Neuerstellungen in Minuten an.';
} else {
    echo '<input type="checkbox" name="brutal_cache_timeval_active" />'.
         '<br /> Wird diese Option deaktiviert, so wird die Cache erst bei einem L&ouml;schaufruf erneuert, '.
         'und niemals zwischendurch. Der Vorteil daran ist, dass wirklich jeder User den Cache erh&auml;lt, '.
         'der Nachteil ist, dass die User immer den Content sehen, welcher nach dem letzten L&ouml;schpunkt '.
         'erstellt wurde.';
}

//use usercache
echo '<br /><br />'.
     '<b>Cache des Users ber&uuml;cksichtigen? </b>';

if ($this->config['use_user_stored'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_use_user_stored" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_use_user_stored" />';
}

echo '<br />Mit dieser Option wird getestet, ob der Besucher die Seite bereits im Cache hat. Mit dieser Option '.
     'kann Traffic gespart werden und der Speed noch mehr erh&ouml;ht werden!'.
     '<br /><br />'.
     '<b>Cache bei Adminaufruf l&ouml;schen? </b>';

//Delete cache by calling a adminpage
if ($this->config['delete_by_admin_call'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_delete_by_admin_call" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_delete_by_admin_call" />';
}

echo '<br />Wird diese Option aktiviert, so wird bei jedem Aufruf einer Adminseite die Cache gel&ouml;scht. '. 
     'Der Vorteil besteht darin, dass die Posts immer Aktuell sind, ebenso wie alle Einstellungen. Der '. 
     'Nachteil besteht darin, dass das Adminmen&uuml; ein wenig l&auml;nger l&auml;d.'.
     '<br /><br />'.
     '<b>Cache minimieren?</b>';

//cache minifing
if ($this->config['minify_cache'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_minify_cache" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_minify_cache" />';
}

echo '<br />Wird diese Option aktivert werden die Cachefiles minimiert und so wird Traffic gespart.'.
     '<br /><br />'.
     '<b>HTTP-Requests reduzieren</b>';

if ($this->config['reduce_http'] == 1) {
    echo '<input checked="checked" type="checkbox" name="brutal_cache_reduce_http" />';
} else {
    echo '<input type="checkbox" name="brutal_cache_reduce_http" />';
}

echo '<br />Mit dieser Option werden CSS und JS Files durchgegangen und direkt mit in das Cachefile geschrieben '.
    'Dadurch können HTTP-Requests gespart werden und das aufbauen der Seite geht schneller. Benötigt wird hierzu '.
    'ein aktives "allow_url_fopen" in der php.ini .'.
    '<br /><br />'.
    '<h3>Brutal Cache Experten Konfiguration</h3>';

echo '<b>Bei welchem Event soll gehooked werden</b>'.
    '<select name="brutal_cache_hook_event">';
//Select hook
switch ($this->config['hook_event']) {
    case 1:
        echo '<option selected="selected">plugins_loaded</option><option>sanitize_comment_cookies</option><option>setup_theme</option>';
        break;
    case 2:
        echo '<option>plugins_loaded</option><option selected="selected">sanitize_comment_cookies</option><option>setup_theme</option>';
        break;
    case 3:
        echo '<option>plugins_loaded</option><option>sanitize_comment_cookies</option><option selected="selected">setup_theme</option>';
        break;
    default:
        echo '<option selected="selected">plugins_loaded</option><option>sanitize_comment_cookies</option><option>setup_theme</option>';
}
echo '</select>'.
     '<br />Hier entscheidet sich, wann das Plugin gehooked wird. Das bedeutet, wie fr&uuml;h, oder bei welchem '.
     'Event dieses Plugin aktiv wird. Dabei hei&szlig;t es, um so h&ouml;her der Eintrag, desto fr&uuml;her '.
     'wird das Plugin ausgef&uuml;hrt. Diese Funktion kann n&uuml;tzlich sein, um mit anderen Plugins, '.
     'vorwiegend Statistik Plugins nicht zu kollidieren. Diese Einstellung solltest du nur &auml;ndern, wenn '.
     'du weißt was das bedeutet!';

//the priority
echo '<br /><br />'.
     '<b>Welche Priorit&auml;t soll Brutal Cache beim hooken haben? </b>'.
     '<input type="text" value="'.$this->config['hook_prioritat'].'" maxlength="2" size="2" name="brutal_cache_hook_prioritat" /><br />'.
     'Die Priorit&auml;t kann zwischen 1 und 20 sein. Die Priorit&auml;t gibt an, wann an dem Hook der Prozess '.
     'ausgef&uuml;hrt wird. 1 ist dabei am fr&uuml;sten, 20 am sp&auml;testen. Diese Funktion dient dazu, den '.
     'Cachevorgang auf die anderen Plugins abzustimmen. <br />'.
     'Diese Angabe wird im Brutal Mode ignoriert!';

//saving button
echo '<br /><br />'.
     '<input type="submit" value="Speichern" name="brutal_cache_change_config" />'.
     '</form>';
//deleting cache
echo '<br /><br /><h3>Cache L&ouml;schen</h3><br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'Hier l&auml;sst sich die Cache manuell l&ouml;schen. Dabei werden alle angelegten Cachefiles gel&ouml;scht.'.
     '<br /><br />'.
     '<input type="submit" value="Cache l&ouml;schen" name="brutal_cache_cache_loeschen" />'.
     '</form>';

echo '<br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'Hier kannst du ein einzelnes File löschen.<br />'.
     '<select name="brutal_cache_onefile">';

     $h = scandir( $this->BRUTAL_CACHE_DIR.'/cache/' );
       foreach( $h as $f ) {
            if ( $f != '.' && $f != '..' && $f != 'index.php' ) {
                echo '<option>'.$f.'</option>';
            }
        }
     unset($f,$h);

echo '</select>'.
     '<input type="submit" value="Cachefile l&ouml;schen" name="brutal_cache_onefile_cache_loeschen" />'.
     '</form>';

//brutal mode menue
echo '<br /><br /><h3>Brutal Mode</h3><br />'.
     '<form action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post">'.
     'ACHTUNG! Der Brutal Mode ver&auml;ndert ihren Blog in einen statischen Blog. Der Geschwindigkeitszuwachs ist '.
     'enorm! Jedoch werden keine WP eigenen Atkionen mehr ausgef&uuml;hrt!'.
     'Dieser Modus ist mit Vorsicht zu genießen, da er nicht f&uuml;r alle Nutzer geeignet ist.'.
     'Sein sie sich also vorher sicher, dass sie dieses Feature wirklich nutzen wollen. Alternativ stellt es'.
     'es aber auch kein Problem dar, diesen Modus wieder zu deaktivieren. Also keine Angst vor dem Ausporbieren.'.
     '<br /><br />';

if ($this->config['brutal_mode'] == 0) {
    echo '<input type="submit" value="Brutal Mode aktivieren" name="brutal_cache_brutal_mode_change" />';
} else {
    echo '<input type="submit" value="Brutal Mode deaktivieren" name="brutal_cache_brutal_mode_change" />';
}

//end designing
echo '</form>'.
     '<br /><br />'.
     '</div>';

?>
